import gradio as gr
import paho.mqtt.client as mqtt
from time import sleep
def do1():
    global msg
    msg=None
    def on_message(client, userdata, message):
        global msg
        msg=message.payload.decode()
    client=mqtt.Client()
    client.on_message=on_message
    client.connect('broker.mqttgo.io',1883,60)
    client.subscribe('race01')
    client.loop_start()
    while msg is None:
        sleep(0.1)
    client.loop_stop()
    client.disconnect()
    return msg
def do2():
    global msg
    msg=None
    def on_message(client, userdata, message):
        global msg
        msg=message.payload.decode()
    client=mqtt.Client()
    client.on_message=on_message
    client.connect('broker.mqttgo.io',1883,60)
    client.subscribe('race02')
    client.loop_start()
    while msg is None:
        sleep(0.1)
    client.loop_stop()
    client.disconnect()
    return msg
def do3():
    global msg
    msg=None
    def on_message(client, userdata, message):
        global msg
        msg=message.payload.decode()
    client=mqtt.Client()
    client.on_message=on_message
    client.connect('broker.mqttgo.io',1883,60)
    client.subscribe('race03')
    client.loop_start()
    while msg is None:
        sleep(0.1)
    client.loop_stop()
    client.disconnect()
    return msg
with gr.Blocks() as demo:
    gr.Markdown("<h1 style='text-align:center; '>出海偵測器</h1>")
    gr.Markdown("<h2 style='text-align:center;'>選擇下面的海邊，讓我們輸出我們即時偵測到的數值，讓您決定要不要出海。</h2>")
    n1 = gr.Button('第1海')
    n2 = gr.Button('第2海')
    n3 = gr.Button('第3海')
    gr.Markdown('我們將會把我們偵測的出的數值,答案提供在下面。')
    oup = gr.Textbox(label='輸出')
    n1.click(fn=do1, inputs=None, outputs=oup)
    n2.click(fn=do2, inputs=None, outputs=oup)
    n3.click(fn=do3, inputs=None, outputs=oup)
demo.launch()
