from rabboni import *
import sys, time
from time import sleep
import paho.mqtt.client as mqtt
broker="broker.mqttgo.io"  
port=1883                  
topic="race01"   
try:
 rabbo = Rabboni(mode = "USB") 
 rabbo.connect()
 print('ok')
except Exception as e:
 print(e)
 print("rabboni沒接到")
 sys.exit( )
print ("Status:",rabbo.Status)
rabbo.read_data()
while True:
    maxcx=0
    mincx=0 
    client = mqtt.Client()
    client.connect(broker, port, 60)
    print('in')
    for i in range(10):
        accx=rabbo.Accx
        if maxcx<accx:
            maxcx=accx
        if mincx>accx:
            mincx=accx
        sleep(0.8)
    print(maxcx-mincx)
    if maxcx-mincx<0.13:
        message ='風平浪靜，適合出海。'
        print(message)
        client.publish(topic, message)
    if 0.13<maxcx-mincx<0.35:
        message ='有些許風浪，但還是能出海。'
        print(message)
        client.publish(topic, message)
    if 0.35<maxcx-mincx<0.55:
        message ='風浪偏大，建議不要出海。'
        print(message)
        client.publish(topic, message)
    if 0.55<maxcx-mincx:
        message ='特大，不適合出海。'
        print(message)
        client.publish(topic, message)
    client.disconnect()
